import { HTMLEventName } from "./dom";
import { MaybeFuture, Observable, Observer } from "./futures";
export type JSON = string | number | boolean | null | JSONObject | JSON[];
interface JSONObject {
    [property: string]: JSON;
}
export type HandlerFunction = (event: Event, handledTarget?: EventTarget | null) => Boolean;
export type Handler = {
    type: string;
    handler: Promise<unknown> | Observable<unknown> | Observer<unknown> | HandlerFunction;
    eventName?: HTMLEventName;
    attribute?: any;
    error?: any;
    termination?: any;
};
export type InlineAttributeHandler = Handler & {
    handler: JSONObject;
};
export type MaybeHandler = MaybeFuture<unknown>;
export {};
